#include "DlgProcs.h"


BOOL CALLBACK LocOpSizeDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	static PLOCOPSIZEPARAM pLocOpSizeParam;
	static BITMAP          bitmap;
	char                   szTmp[10];
	long									 Counter;
	int										 iResult;

	switch (message)
		{
		case WM_INITDIALOG:
			pLocOpSizeParam = (PLOCOPSIZEPARAM) lParam;
			if (!pLocOpSizeParam->hBitmap)
			{
				EndDialog(hDlg, FALSE);
				return TRUE;
			}
			GetObject(pLocOpSizeParam->hBitmap, sizeof(BITMAP), &bitmap);
			if (pLocOpSizeParam->Height<1)
			{
				pLocOpSizeParam->Height=5;
				pLocOpSizeParam->Width=5;
				pLocOpSizeParam->Param=30;
				pLocOpSizeParam->Compare=20;
			}
			if (pLocOpSizeParam->Width>bitmap.bmWidth)  pLocOpSizeParam->Width=1;
			if (pLocOpSizeParam->Height>bitmap.bmHeight)  pLocOpSizeParam->Height=1;
			if ((pLocOpSizeParam->Operation!=IDM_LOCOP_NORMALIZE)
				     &&  (pLocOpSizeParam->Param > pLocOpSizeParam->Width*pLocOpSizeParam->Height))
					pLocOpSizeParam->Param = pLocOpSizeParam->Width*pLocOpSizeParam->Height;
			for (Counter = 1; Counter<=bitmap.bmWidth/2+1; Counter += 2)
			{
				itoa(Counter, szTmp, 10);
				SendDlgItemMessage(hDlg, IDC_WIDTH, CB_ADDSTRING, 0, (LPARAM) szTmp);
			}
			SendDlgItemMessage(hDlg, IDC_WIDTH, CB_SETCURSEL, pLocOpSizeParam->Width/2, 0);
			for (Counter = 1; Counter<=bitmap.bmHeight/2+1; Counter += 2)
			{
				itoa(Counter, szTmp, 10);
				SendDlgItemMessage(hDlg, IDC_HEIGHT, CB_ADDSTRING, 0, (LPARAM) szTmp);
			}
			SendDlgItemMessage(hDlg, IDC_HEIGHT, CB_SETCURSEL, pLocOpSizeParam->Height/2, 0);
			SetDlgItemInt(hDlg, IDC_EDITBOX, pLocOpSizeParam->Param, FALSE);
			SetDlgItemInt(hDlg, IDC_EDITBOX2, pLocOpSizeParam->Compare, FALSE);
			if (pLocOpSizeParam->Operation==IDM_LOCOP_NORMALIZE)
			{
				SetDlgItemText(hDlg, IDC_PARAMETER_CAPTION, TEXT("Max-Min mindestens:"));
				ShowWindow(GetDlgItem(hDlg, IDC_MIN), SW_HIDE);
				ShowWindow(GetDlgItem(hDlg, IDC_MEDIAN), SW_HIDE);
				ShowWindow(GetDlgItem(hDlg, IDC_MAX), SW_HIDE);
				ShowWindow(GetDlgItem(hDlg, IDC_LABEL_EDITBOX2), SW_SHOW);
				ShowWindow(GetDlgItem(hDlg, IDC_EDITBOX2), SW_SHOW);
			}
			return TRUE;

		case WM_COMMAND:
			switch (LOWORD (wParam))
			{
			
			case IDC_EDITBOX:
				if (HIWORD(wParam) == EN_CHANGE)
				{
					if (pLocOpSizeParam->Operation == IDM_LOCOP_RANKORDER)
					{
						Counter = (SendDlgItemMessage(hDlg, IDC_WIDTH, CB_GETCURSEL, 0, 0)*2+1)
							         * (SendDlgItemMessage(hDlg, IDC_HEIGHT, CB_GETCURSEL, 0, 0)*2+1);
						iResult = GetDlgItemInt(hDlg, IDC_EDITBOX, NULL, FALSE);
						if (iResult<1  ||  iResult>Counter)
							EnableWindow(GetDlgItem(hDlg, IDOK), FALSE);
						else
							EnableWindow(GetDlgItem(hDlg, IDOK), TRUE);
					}
					if (pLocOpSizeParam->Operation == IDM_LOCOP_NORMALIZE)
					{
						iResult = GetDlgItemInt(hDlg, IDC_EDITBOX, NULL, FALSE);
						if (iResult<1  ||  iResult>255)
							EnableWindow(GetDlgItem(hDlg, IDOK), FALSE);
						else
							EnableWindow(GetDlgItem(hDlg, IDOK), TRUE);
					}
				}
				return TRUE;

			case IDC_EDITBOX2:
				if (HIWORD(wParam) == EN_CHANGE)
				{
					iResult = GetDlgItemInt(hDlg, IDC_EDITBOX2, NULL, FALSE);
					if (iResult<1  ||  iResult>255)
						EnableWindow(GetDlgItem(hDlg, IDOK), FALSE);
					else
						EnableWindow(GetDlgItem(hDlg, IDOK), TRUE);
				}
				return TRUE;

			case IDC_MAX:
				Counter = (SendDlgItemMessage(hDlg, IDC_WIDTH, CB_GETCURSEL, 0, 0)*2+1)
					         * (SendDlgItemMessage(hDlg, IDC_HEIGHT, CB_GETCURSEL, 0, 0)*2+1);
				SetDlgItemInt(hDlg, IDC_EDITBOX, Counter, FALSE);
				return TRUE;

			case IDC_MEDIAN:
				Counter = (SendDlgItemMessage(hDlg, IDC_WIDTH, CB_GETCURSEL, 0, 0)*2+1)
					         * (SendDlgItemMessage(hDlg, IDC_HEIGHT, CB_GETCURSEL, 0, 0)*2+1);
				SetDlgItemInt(hDlg, IDC_EDITBOX, Counter/2+1, FALSE);
				return TRUE;
			
			case IDC_MIN:
				SetDlgItemInt(hDlg, IDC_EDITBOX, 1, FALSE);
				return TRUE;

			case IDOK:
				pLocOpSizeParam->Width = (SendDlgItemMessage(hDlg, IDC_WIDTH, CB_GETCURSEL, 0, 0)*2+1);
				pLocOpSizeParam->Height = (SendDlgItemMessage(hDlg, IDC_HEIGHT, CB_GETCURSEL, 0, 0)*2+1);
				pLocOpSizeParam->Param = GetDlgItemInt(hDlg, IDC_EDITBOX, NULL, FALSE);
				pLocOpSizeParam->Compare = GetDlgItemInt(hDlg, IDC_EDITBOX2, NULL, FALSE);
				EndDialog(hDlg, TRUE);
				return TRUE;

			case IDCANCEL:
				EndDialog(hDlg, FALSE);
				return TRUE;
			}
			break;
	}
	return FALSE;

}