#include "DlgProcs.h"



BOOL CALLBACK ParticleParamsDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	static  PPARTICLEPARAM  pParticleParam;
	const   RGBQUAD         rgbBlack = {0, 0, 0, 0};
	int     i;
	RGBQUAD ShowRGBPal[256];


	switch (message)
		{
		case WM_INITDIALOG:
			pParticleParam = (PPARTICLEPARAM) lParam;
			SetDlgItemInt(hDlg, IDC_MINGRAY, pParticleParam->MinGrayVal, FALSE);
			SetDlgItemInt(hDlg, IDC_MINAREA, pParticleParam->MinArea, FALSE);
			SetDlgItemInt(hDlg, IDC_MAXAREA, pParticleParam->MaxArea, FALSE);
			SendMessage(hDlg, WM_COMMAND, IDC_MINGRAY | (EN_CHANGE<<16), 0);
			return TRUE;

		case WM_COMMAND:
			switch (LOWORD (wParam))
			{
			case IDC_MINGRAY:
			case IDC_MINAREA:
			case IDC_MAXAREA:
				if (HIWORD(wParam)==EN_CHANGE)
				{
					if (      GetDlgItemInt(hDlg, IDC_MINGRAY, NULL, FALSE)<0
						    ||  GetDlgItemInt(hDlg, IDC_MINGRAY, NULL, FALSE)>255
						    ||  GetDlgItemInt(hDlg, IDC_MINAREA, NULL, FALSE)<0
								||  GetDlgItemInt(hDlg, IDC_MAXAREA, NULL, FALSE)<1
								||  GetDlgItemInt(hDlg, IDC_MAXAREA, NULL, FALSE)<GetDlgItemInt(hDlg, IDC_MINAREA, NULL, FALSE))
					{
						EnableWindow(GetDlgItem(hDlg, IDOK), FALSE);
						SetRGBPalette(pParticleParam->hBitmap, pParticleParam->OldRGBPal);
						InvalidateRect(GetParent(hDlg), NULL, FALSE);
					}
					else
					{
						EnableWindow(GetDlgItem(hDlg, IDOK), TRUE);
						if (LOWORD(wParam)==IDC_MINGRAY)
						{
							i=0;
							while ((UINT) i<GetDlgItemInt(hDlg, IDC_MINGRAY, NULL, FALSE))
							{
								ShowRGBPal[i] = rgbBlack;
								ShowRGBPal[i].rgbBlue = 50;
								i++;
							}
							while (i<256)
							{
								ShowRGBPal[i] = pParticleParam->OldRGBPal[i];
								i++;
							}
							SetRGBPalette(pParticleParam->hBitmap, ShowRGBPal);
							InvalidateRect(GetParent(hDlg), NULL, FALSE);
						}
					}
				}
				return TRUE;

			case IDOK:
				pParticleParam->MinGrayVal = GetDlgItemInt(hDlg, IDC_MINGRAY, NULL, FALSE);
				pParticleParam->MinArea = GetDlgItemInt(hDlg, IDC_MINAREA, NULL, FALSE);
				pParticleParam->MaxArea = GetDlgItemInt(hDlg, IDC_MAXAREA, NULL, FALSE);
				SetRGBPalette(pParticleParam->hBitmap, pParticleParam->OldRGBPal);
				InvalidateRect(GetParent(hDlg), NULL, FALSE);
				EndDialog(hDlg, TRUE);
				return TRUE;

			case IDCANCEL:
				SetRGBPalette(pParticleParam->hBitmap, pParticleParam->OldRGBPal);
				InvalidateRect(GetParent(hDlg), NULL, FALSE);
				EndDialog (hDlg, FALSE);
				return TRUE;
			}
			break;
	}
	return FALSE;
}
