#include "DlgProcs.h"

BOOL ValidateData(HWND hDlg, PSELMANUALPARAM pSelMan, long BitmapWidth, long BitmapHeight);



BOOL CALLBACK SelectManualDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	static PSELMANUALPARAM  pSelManualParam;
	static RECT            *pSelRect;
  static long             BitmapWidth, BitmapHeight, Width, Height;
	BITMAP                  bitmap;

	switch (message)
		{
		case WM_INITDIALOG:
			pSelManualParam = (PSELMANUALPARAM) lParam;
			if (!pSelManualParam->hBitmap) 
			{
				EndDialog(hDlg, FALSE);
				return TRUE;
			}
			GetObject(pSelManualParam->hBitmap, sizeof (BITMAP), &bitmap);
			BitmapWidth  = bitmap.bmWidth;
			BitmapHeight = bitmap.bmHeight;
			pSelRect = pSelManualParam->pRect;
			Width  = pSelManualParam->LastRect.right - pSelManualParam->LastRect.left + 1;
			Height = pSelManualParam->LastRect.top   - pSelManualParam->LastRect.bottom + 1;

			if (pSelManualParam->bFFT)
			{
				SetDlgItemText(hDlg, IDC_FRAME_BITMAP, TEXT("Spektrum"));
				SetDlgItemText(hDlg, IDC_LABEL_COORD, TEXT("Zentriert um"));
				SetDlgItemText(hDlg, IDC_LABEL_X, TEXT("Kx:"));
				SetDlgItemText(hDlg, IDC_LABEL_Y, TEXT("Ky:"));
			}
			SetDlgItemInt(hDlg, IDC_XPOS, pSelManualParam->LastRect.left, FALSE);
			SetDlgItemInt(hDlg, IDC_YPOS, pSelManualParam->LastRect.bottom, FALSE);
			SetDlgItemInt(hDlg, IDC_WIDTH, Width, FALSE);
			SetDlgItemInt(hDlg, IDC_HEIGHT, Height, FALSE);
			if (pSelManualParam->bFFT)
			{
				SetDlgItemInt(hDlg, IDC_BITMAPWIDTH , BitmapWidth /2, FALSE);
				SetDlgItemInt(hDlg, IDC_BITMAPHEIGHT, BitmapHeight/2, FALSE);
			}
			else
			{
				SetDlgItemInt(hDlg, IDC_BITMAPWIDTH, BitmapWidth, FALSE);
				SetDlgItemInt(hDlg, IDC_BITMAPHEIGHT, BitmapHeight, FALSE);
			}
			InvalidateRect(GetParent(hDlg), NULL, FALSE);
			return TRUE;

		case WM_COMMAND:
			switch (LOWORD (wParam))
			{
			case IDC_XPOS:
			case IDC_YPOS:
			case IDC_WIDTH:
			case IDC_HEIGHT:
				if (HIWORD(wParam)==EN_CHANGE)
				{
					if (!ValidateData(hDlg, pSelManualParam, BitmapWidth, BitmapHeight))
					{
						pSelRect->left   = 0;
						pSelRect->bottom = 0;
						pSelRect->right  = BitmapWidth  - 1;
						pSelRect->top    = BitmapHeight - 1;
						EnableWindow(GetDlgItem(hDlg, IDOK), FALSE);
					}
					else
					{
						EnableWindow(GetDlgItem(hDlg, IDOK), TRUE);
					}
					InvalidateRect(GetParent(hDlg), NULL, FALSE);
				}
				return TRUE;

			case IDOK:
				EndDialog(hDlg, TRUE);
				return TRUE;

			case IDCANCEL:
				EndDialog (hDlg, FALSE);
				return TRUE;
			}
			break;
	}
	return FALSE;
}



BOOL ValidateData(HWND hDlg, PSELMANUALPARAM pSelMan, long BitmapWidth, long BitmapHeight)
{
	TCHAR  szTmp[81];
	int    Counter;
	long   xPos, yPos;
	RECT   *pSelRect = pSelMan->pRect;

	GetDlgItemText(hDlg, IDC_XPOS, szTmp, 80);
	if (strlen(szTmp)>78)  return FALSE;
	Counter=0;
	if (szTmp[0]=='-'  &&  pSelMan->bFFT)  Counter=1;
	while (szTmp[Counter])
	{
		if (szTmp[Counter]<'0'  ||  szTmp[Counter]>'9')  return FALSE;
		Counter++;
	}
	xPos = atol(szTmp);

	GetDlgItemText(hDlg, IDC_YPOS, szTmp, 80);
	if (strlen(szTmp)>78)  return FALSE;
	Counter=0;
	if (szTmp[0]=='-'  &&  pSelMan->bFFT)  Counter=1;
	while (szTmp[Counter])
	{
		if (szTmp[Counter]<'0'  ||  szTmp[Counter]>'9')  return FALSE;
		Counter++;
	}
	yPos = atol(szTmp);

	if (pSelMan->bFFT)
	{
		pSelRect->left   = BitmapWidth  / 2 + xPos;
		pSelRect->bottom = BitmapHeight / 2 + yPos;
		pSelRect->right  = pSelRect->left   + GetDlgItemInt(hDlg, IDC_WIDTH , NULL, FALSE);
		pSelRect->top    = pSelRect->bottom + GetDlgItemInt(hDlg, IDC_HEIGHT, NULL, FALSE);
		pSelRect->left   = pSelRect->left   - GetDlgItemInt(hDlg, IDC_WIDTH , NULL, FALSE);
		pSelRect->bottom = pSelRect->bottom - GetDlgItemInt(hDlg, IDC_HEIGHT, NULL, FALSE);
		if (xPos == 0  &&  pSelRect->left   == 0)  pSelRect->right = BitmapWidth  - 1;
		if (yPos == 0  &&  pSelRect->bottom == 0)  pSelRect->top   = BitmapHeight - 1;
	}
	else
	{
		pSelRect->left   = xPos;
		pSelRect->bottom = yPos;
		pSelRect->right  = pSelRect->left   + GetDlgItemInt(hDlg, IDC_WIDTH , NULL, FALSE) - 1;
		pSelRect->top    = pSelRect->bottom + GetDlgItemInt(hDlg, IDC_HEIGHT, NULL, FALSE) - 1;
	}
	if (pSelRect->left<0  ||  pSelRect->bottom<0)  return FALSE;
	if (pSelRect->right>BitmapWidth-1  ||  pSelRect->top>BitmapHeight-1  ||  GetDlgItemInt(hDlg, IDC_WIDTH, NULL, FALSE)<0  ||  GetDlgItemInt(hDlg, IDC_HEIGHT, NULL, FALSE)<0)  return FALSE;
	if (!pSelMan->bFFT  &&  (GetDlgItemInt(hDlg, IDC_WIDTH, NULL, FALSE)<=0  ||  GetDlgItemInt(hDlg, IDC_HEIGHT, NULL, FALSE)<=0))  return FALSE;

	return TRUE;
}
