#include "Undo.h"
#include "DIBs.h"

long    UndoWidth = 0, UndoWidthBytes = 0, UndoHeight = 0;
RGBQUAD UndoPalette[256];
BYTE    *pUndoBits = 0;
TCHAR   *szUndoWhat = 0;
TCHAR   szMenuUndoText[80] = TEXT("&Rckgngig");
BOOL    bReDo = FALSE;


BOOL SaveBitsForUndo(BYTE *pBits, long Width, long WidthBytes, long Height, TCHAR* szWhatToUndo)
{
	long Pos1, Pos2;
	
	bReDo = FALSE;
	if (Height != UndoHeight || Width != UndoWidth || WidthBytes != UndoWidthBytes)
	{
		if (pUndoBits) free(pUndoBits);
		pUndoBits = (BYTE*) malloc(WidthBytes*Height);
		UndoWidth = Width;
		UndoWidthBytes = WidthBytes;
		UndoHeight = Height;
	}

	if (!pUndoBits)
	{
		ClrUndoBuf();
		return FALSE;
	}
	CopyMemory(pUndoBits, pBits, WidthBytes*Height);
	
	if (szUndoWhat)  free(szUndoWhat);
	szUndoWhat = (TCHAR*) malloc(strlen(szWhatToUndo)+1);
	if (szUndoWhat) //  strcpy(szUndoWhat, szWhatToUndo);
  {
		Pos1 = Pos2 = 0;
		while (szWhatToUndo[Pos1])
		{
			if (szWhatToUndo[Pos1] != '&'  &&  szWhatToUndo[Pos1] != '.')
			{
				szUndoWhat[Pos2] = szWhatToUndo[Pos1];
				Pos2++;
			}
			Pos1++;
		}
		szUndoWhat[Pos2] = 0;
	}
	return TRUE;
}


void SavePaletteForUndo(HBITMAP hBitmap)
{
	GetRGBPalette(hBitmap, UndoPalette);
}


BOOL SaveForUndo(HBITMAP hBitmap, TCHAR* szWhatToUndo)
{
	BITMAP bitmap;

	GetObject (hBitmap, sizeof (BITMAP), &bitmap);
  GetRGBPalette(hBitmap, UndoPalette);
  return SaveBitsForUndo((BYTE*) bitmap.bmBits, bitmap.bmWidth, bitmap.bmWidthBytes, bitmap.bmHeight, szWhatToUndo);
}



BOOL CanUndo(HBITMAP hBitmap)
{
  BITMAP bitmap;

	if (!hBitmap) return FALSE;
	GetObject (hBitmap, sizeof (BITMAP), &bitmap);
	if (!pUndoBits)  return FALSE;
	if (bitmap.bmWidth != UndoWidth)  return FALSE;
	if (bitmap.bmWidthBytes != UndoWidthBytes)  return FALSE;
	if (bitmap.bmHeight != UndoHeight)  return FALSE;

	return TRUE;
}



TCHAR* MenuUndoText(HBITMAP hBitmap)
{
	if (CanUndo(hBitmap))
	{
		if (bReDo)
			strcpy(szMenuUndoText, TEXT("Wiederhe&rstellen: "));
		else
			strcpy(szMenuUndoText, TEXT("&Rckgngig: "));
		strcat(szMenuUndoText, szUndoWhat);
	}
	else	strcpy(szMenuUndoText, TEXT("&Rckgngig"));
	strcat(szMenuUndoText, TEXT("\tStrg+Z"));
	
	return szMenuUndoText;
}



BOOL Undo(HBITMAP hBitmap)
{
  BITMAP bitmap;
	BYTE *pSwapBits = NULL, *pBits = NULL, bSwap = 0;
	RGBQUAD SwapPalette[256];
	long Counter;

  if (!CanUndo(hBitmap))  return FALSE;
	GetObject (hBitmap, sizeof (BITMAP), &bitmap);
	GetRGBPalette(hBitmap, SwapPalette);
	SetRGBPalette(hBitmap, UndoPalette);
	for (Counter=0; Counter<256; Counter++)  UndoPalette[Counter] = SwapPalette[Counter];
  pBits = (BYTE*) bitmap.bmBits;
	pSwapBits	= (BYTE*) malloc(UndoWidthBytes*UndoHeight);
	if (pSwapBits)
	{
		CopyMemory(pSwapBits, pBits, UndoWidthBytes*UndoHeight);
		CopyMemory(pBits, pUndoBits, UndoWidthBytes*UndoHeight);
		CopyMemory(pUndoBits, pSwapBits, UndoWidthBytes*UndoHeight);
		free(pSwapBits);
	}
	else
	{
		for (Counter = 0; Counter < UndoWidthBytes*UndoHeight; Counter++)
		{
			bSwap = pBits[Counter];
			pBits[Counter] = pUndoBits[Counter];
			pUndoBits[Counter] = bSwap;
		}
	}

  bReDo = !bReDo;
	return TRUE;
}



void UndoPixel(BYTE *pBits, long WidthBytes, long x, long y)
{
	pBits[y*WidthBytes+x] = pUndoBits[y*WidthBytes+x];
}



void ClrUndoBuf()
{
	int i;

	UndoWidth = 0;
	UndoWidthBytes = 0;
	UndoHeight = 0;
	for (i=0; i<256; i++)
	{
		UndoPalette[i].rgbBlue     = i;
		UndoPalette[i].rgbGreen    = i;
		UndoPalette[i].rgbRed      = i;
		UndoPalette[i].rgbReserved = 0;
	}
	if (pUndoBits)  free(pUndoBits);
	pUndoBits = NULL;
	if (szUndoWhat) free(szUndoWhat);
	szUndoWhat = NULL;
	bReDo = FALSE;
}
